//https://www.sojson.com/javascriptobfuscator.html js加密混淆地址
//关闭窗口
function closewindows() {
    try {
        cordova.exec(null, null, "CustomInteractivePlugin", "gotoHome", [{ fromnurse: "1" }]);
    } catch (e) {
    }
}
//添加就诊人
function addNewPatient(addNewPatientCallback) {
    //window.alert('addNewPatient');
    cordova.exec(
        addNewPatientCallback,
        null,
        "CustomInteractivePlugin",
        "addNewPatient",
        []
    );
}


//服务地址
function chooseNurseServiceAddress(
    chooseNurseServiceAddressCallBack,
    patientName,
    sex,
    phone
) {
    // //window.alert('chooseNurseServiceAddress');
    cordova.exec(
        chooseNurseServiceAddressCallBack,
        null,
        "CustomInteractivePlugin",
        "chooseNurseServiceAddress",
        [
            {
                PatientName: patientName,
                Sex: sex,
                Phone: phone,
            },
        ]
    )
}

// 拍照、选择相册照片
function getPictureNative(getPictureNativeCallback, Type, MaxNumber) {
    //window.alert("getPictureNative")
    cordova.exec(
        getPictureNativeCallback,
        null,
        "CustomInteractivePlugin",
        "getPictureNative",
        [
            {
                Type: Type,
                MaxNumber: MaxNumber,
            },
        ]
    )
}

// 前往沟通
function NursePatientChat(BussNo, CID) {
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "NursePatientChat",
        [
            {
                BussNo: BussNo,
                CID: CID,
            }
        ]
    );
}

// 发起支付
function nurseServicePayWithOrderInfo(
    paySuccessCallback,
    errorCallback,
    CID,
    BussNo,
    BussType,
    OrderMoney,
    OrgID,
    OrgName,
    Source,
    PayType,
    BankType,
    NeedPay,
    OrderTitle,
    OrderSummary,
    SerialNumber,
    IsContinuePay,
    Remark,
    RegID,
    RegCode,
    PID,
    HID
) {
    cordova.exec(
        paySuccessCallback,
        errorCallback,
        "CustomInteractivePlugin",
        "nurseServicePayWithOrderInfo",
        [
            {
                CID: CID,
                BussNo: BussNo,
                BussType: BussType,
                OrderMoney: OrderMoney,
                OrgID: OrgID,
                OrgName: OrgName,
                Source: Source,
                PayType: PayType,
                BankType: BankType,
                NeedPay: NeedPay,
                OrderTitle: OrderTitle,
                OrderSummary: OrderSummary,
                SerialNumber: SerialNumber,
                IsContinuePay: IsContinuePay,
                Remark: Remark,
                RegID: RegID,
                RegCode: RegCode,
                PID: PID,
                HID: HID
            }
        ]
    );
}

//跳转至消息页面
function getMessageListAction() {
    //window.alert('getMessageListAction');
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "getMessageListAction",
        []
    );
}

//左上角返回
function gotoHome(isFromNurse, Qroute) {
    //window.alert('gotoHome');
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "gotoHome",
        [
            {
                isFromNurse: isFromNurse,
                Qroute: Qroute
            }
        ]
    );
}

//登录交互
function toQYiLoginPage(LoginSuccessCallBack, route) {
    //window.alert('toQYiLoginPage');
    cordova.exec(
        LoginSuccessCallBack,
        null,
        "CustomInteractivePlugin",
        "toQYiLoginPage",
        [
            {
                route: route
            }
        ]
    );
}

//图片预览
function showimg(imgs, index) {
    //window.alert('showimg');
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "showimg",
        [
            {
                imgs: imgs,
                index: index
            }
        ]
    );
}

// 首页消息监听
function addUnReadListenner(successCallback, errorCallback) {
    cordova.exec(
        successCallback,
        errorCallback,
        "CustomInteractivePlugin",
        "addUnReadListenner",
        []
    );
}

// 首页获取消息未读数量
function unReadMessageNumber(successCallback, errorCallback) {
    cordova.exec(
        successCallback,
        errorCallback,
        "CustomInteractivePlugin",
        "unReadMessageNumber",
        []
    );
}

// 状态栏交互
function changeStatusBar(style) {
    cordova.exec(
        null,
        null,
        "StatusBar",
        "changeStatusBar",
        [
            {
                style: style
            }
        ]
    );
}

// 选择就医档案
function consultMyHospitalRecords(
    consultMyHospitalRecordsCallBack,
    pid, patientname, sex, age, idcard, phone, medcardid, hid
) {
    cordova.exec(
        consultMyHospitalRecordsCallBack,
        null,
        "CustomInteractivePlugin",
        "consultMyHospitalRecords",
        [
            {
                pid: pid,
                patientname: patientname,
                sex: sex,
                age: age,
                idcard: idcard,
                phone: phone,
                medcardid: medcardid,
                hid: hid,
            },
        ]
    )
}

// 前往医嘱
function consultPatientHospitalRecordDetails(RegID) {
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "consultPatientHospitalRecordDetails",
        [
            {
                RegID: RegID,
            }
        ]
    );
}

// 读取本地数据库
function getSqliteData(successCallback,errorCallback,key) {
    cordova.exec(
        successCallback,
        errorCallback,
        "CustomInteractivePlugin",
        "getSqliteData",
        [
            {
                key: key,
            }
        ]
    );
}

// ios返回处理
// ios进入首页
function canSlide() {
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "canSlide",
        []
    );
}
// ios离开首页
function canNotSlide() {
    //window.alert('canNotSlide');
    cordova.exec(
        null,
        null,
        "CustomInteractivePlugin",
        "canNotSlide",
        []
    );
}

var app = {

    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },

    // Bind any events that are required.
    // Usually you should subscribe on 'deviceready' event to know, when you can start calling cordova modules
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('chcp_updateIsReadyToInstall', this.onUpdateReady, false);
    },

    // deviceready Event Handler
    onDeviceReady: function () {
        console.log('Device is ready for work');
    },

    // chcp_updateIsReadyToInstall Event Handler
    onUpdateReady: function () {
        console.log('Update is ready for installation');
    }
};

app.initialize();
var isuse = false
function getVersionInfo() {
    if (!isuse) {
        isuse = true
        cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 1, msg: "" }]);
        fetchUpdate()
    }
}
function fetchUpdate() {
    var options = {
        'config-file': loadUpdateUrl() + '/chcp.json'
    };
    chcp.fetchUpdate(updateCallback, options);
    function updateCallback(error, data) {
        if (error) {
            console.log('没有可用更新', error.code, error.description);
        }
        checkIsUpdateAvailableForInstallation()
    }
}
function checkIsUpdateAvailableForInstallation() {
    chcp.isUpdateAvailableForInstallation(callbackMethod);
    function callbackMethod(error, data) {
        if (error) {
            cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 3, msg: "" }]);
            console.log('没有需要安装的更新');
        } else {
            cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 2, msg: "检测到有新的更新:" + data.readyToInstallVersion + "，即将安装更新……" }]);
            installUpdate()
        }
    }
}
function installUpdate() {
    chcp.installUpdate(installationCallback);
    function installationCallback(error) {
        if (error) {
            cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 5, msg: "更新失败" }]);
        } else {
            cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 4, msg: "更新完毕" }]);
        }
    }
}

//向原生调用实名认证
function callVerified(pid, successCallback, errorCallback) {
    try {
        cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "callVerified", [{ pid: pid }]);
    } catch (e) {
        //console.log(e)
    }
}
//关闭微信窗口
function closeWx() {
    WeixinJSBridge.call('closeWindow');
}
//隐藏右上角三个点按钮
function hideOptionMenu() {
    WeixinJSBridge.call('hideOptionMenu');
}
//是否在微信里
function isinwx() {
    var ua = navigator.userAgent.toLowerCase();
    if (ua.match(/MicroMessenger/i) == "micromessenger") {
        return true
    } else {
        return false
    }
}


//base64转换
var Base64 = {

    // private property
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode: function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode: function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode: function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }
}
function encodeToBase64(str) {
    return Base64.encode(str);
}
function decodeToBase64(str) {
    return Base64.decode(str);
}
function getPicture(sourceType, successCallback, errorCallback) {
    navigator.camera.getPicture(successCallback, errorCallback, {
        quality: 50,
        destinationType: 0,//返回base64编码字符串
        sourceType: sourceType,
        encodingType: 0,//返回JPEG编码图像。
        mediaType: 0//仅允许选择图片。
    })

}


