//https://www.sojson.com/javascriptobfuscator.html js加密混淆地址
//下载文件
function download(url) {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('documentTapped', { url: url }, function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.documentTapped(url);
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.documentTapped.postMessage({ url: url });
    }
  } catch (e) {
  }
}

//跳转国新药品商城
function toDrugMallWithURL(url) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "toDrugMallWithURL", [{ drugmallurl: url }]);
  } catch (e) {
    console.log(e)
  }
}


//发送到
function toCircleEditApp(circleofFriendsId) {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('editCircle', { id: circleofFriendsId }, function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.editCircle(circleofFriendsId);
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.editCircle.postMessage({ id: circleofFriendsId });
    }
  } catch (e) {
  }
}
function toPublicAticle() {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('publicAticle');
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.publicAticle(circleofFriendsId);
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.publicAticle.postMessage();
    }
  } catch (e) {
  }
}
//关闭窗口
function closewindowsJs() {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('gotoHome', '', function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.gotoHome();
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.gotoHome.postMessage("gotoHome");
    }
  } catch (e) {
  }
}

//调用原生，弹出扫二维码页面

function swipeQRCodeWithCallBack(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "toAppQrCode", []);
  } catch (e) {
    //console.log(e)
  }
}
//网约护士
function networNurseCallBack() {
  try {
    cordova.exec(
      null,
      null,
      "CustomInteractivePlugin",
      "networNurseCallBack",
      []
    );
  } catch (e) {
    //console.log(e)
  }
}
//网约护士返回刷新平台页面
function addGotohomeListener(successCallback, errorCallback){
  try {
      cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addGotohomeListener", []);
  } catch (e) {
      //console.log(e)
  }
}
//调用原生问消息未读数
function unReadMessageNumber(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "unReadMessageNumber", []);
  } catch (e) {
    //console.log(e)
  }
}

//调用原生问消息未读数
function addUnReadListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addUnReadListenner", []);
  } catch (e) {
    //console.log(e)
  }
}


//我的问诊消息
function getIHospitalNewMessageListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getIHospitalNewMessageListenner", []);
  } catch (e) {
    //console.log(e)
  }
}
//登录状态回调
function loginStatusListenner(successCallback, errorCallback) {
  try {
      cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "loginStatusListenner", []);
  } catch (e) {
      //console.log(e)
  }
}
//调用原生通知弹登录
function showLoginListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "showLoginListenner", []);
  } catch (e) {
    //console.log(e)
  }
}
function addIHospitalNewMessageListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addIHospitalNewMessageListenner", []);
  } catch (e) {
    //console.log(e)
  }
}
// 客服未读消息
function addCareateRobotMessageListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addCareateRobotMessageListenner", []);
  } catch (e) {
    //console.log(e)
  }
}
function getCareateRobotMessageListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getCareateRobotMessageListenner", []);
  } catch (e) {
    //console.log(e)
  }
}
function downloadfile(url, fileName) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "downloadfile", [{ url: url, fileName: fileName }]);
  } catch (e) {
    //console.log(e)
  }
}
function addAIServiceMessageCountListener (successCallback, errorCallback){
    try {
        cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addAIServiceMessageCountListener", []);
    } catch (e) {
        //console.log(e)
    }
}
function AIServiceMessageCountCleared(successCallback, errorCallback) {
    try {
        cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "AIServiceMessageCountCleared", []);
    } catch (e) {
        //console.log(e)
    }
}
function addAIServiceNotificationMessageTappedListener(successCallback, errorCallback) {
    try {
        cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addAIServiceNotificationMessageTappedListener", []);
    } catch (e) {
        //console.log(e)
    }
}
function downloadfile(url,fileName){
    try {
        cordova.exec(null, null, "CustomInteractivePlugin", "downloadfile", [{url:url,fileName:fileName}]);
    } catch (e) {
        //console.log(e)
    }
}
//获取图片
function getPictureNative(successCallback, errorCallback, Type, MaxNumber) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getPictureNative", [{ Type: Type, MaxNumber: MaxNumber }]);
  } catch (e) {
    //console.log(e)
  }
}
//调用原生聊天页面
function showChatView(IGID, IGSaleID, EndTime, DocID, DeptName, DeptID, DoctorName, DocSex, PatientCID, PID, PatientName, PatientSex, DocCID, hOrgID, closeWeb, isHistory) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "showChatView", [{ IGID: IGID, IGSaleID: IGSaleID, EndTime: EndTime, DocID: DocID, DeptID: DeptID, DeptName: DeptName, DoctorName: DoctorName, PatientName: PatientName, DocSex: DocSex, PatientSex: PatientSex, PatientCID: PatientCID, PID: PID, DocCID: DocCID, hOrgID: hOrgID, closeWeb: closeWeb, isHistory: isHistory }]);
  } catch (e) {
    //console.log(e)
  }
}
// 住院证按钮；
function HospitalizationCallBack(data) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "HospitalizationCallBack", [{ data: data }]);
  } catch (e) {
    //console.log(e)
  }
}
//h5版本号；
function H5Version(Ver) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "H5Version", [{ Ver: Ver }]);
  } catch (e) {
    //console.log(e)
  }
}
function loginPageAllReadyPushed() {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "loginPageAllReadyPushed", []);
  } catch (e) {
    //console.log(e)
  }
}

//调用原生注册***
function addSecuKeyListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addSecuKeyListenner", []);
  } catch (e) {
    //console.log(e)
  }
}

//调用原生获取已安装地图
function addInstallMapListenner(successCallback, errorCallback){
    try{
        cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getInstallMap", []);
    }catch(e){

    }
}

//调用原生注册扫码并返回结果
function addSweepCodeListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addSweepCodeListenner", []);
  } catch (e) {
    //console.log(e)
  }
}


//调用原生获取经纬度并返回结果
function addGetLocationListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addGetLocationListenner", []);
  } catch (e) {
    //console.log(e)
  }
}



//调用原生，监听登出
function addLogoutListenner(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "addLogoutListenner", []);
  } catch (e) {
    //console.log(e)
  }
}


//调用原生改变状态栏颜色
function changeStatusBarColorWithStyle(barStyle) {
  //console.log("changeStatusBarColorWithStyle");
  try {
    cordova.exec(null, null, "StatusBar", "changeStatusBarColorWithStyle", [{ barStyle: barStyle }]);
  } catch (e) {

  }
}

function changeStatusBarColor(color) {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('changeStatusBarColor');
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.changeStatusBarColor(color);
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.changeStatusBarColor.postMessage(color);
    }
  } catch (e) {
  }
}

function changeStatusBar(isOverlay, color, style) {//isOverlay：是否在页面上，color：不在页面上时的颜色，style：0，黑色1，白色字体
  //console.log("changeStatusBar");
  try {
    cordova.exec(null, null, "StatusBar", "changeStatusBar", [{ isOverlay: isOverlay, color: color, style: style }]);
  } catch (e) {

  }
}

//调用IM消息页面

function showIMMessage() {
  //console.log("showIMMessage");
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "getMessageListAction", []);
  } catch (e) {
  }
}

//发送图片让原生显示web调用
function showimgjs(imgs, index) {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('showimg', { imgs: imgs, index: index }, function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.showimg(JSON.stringify({ imgs: imgs, index: index }));
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.showimg.postMessage({ imgs: imgs, index: index });
    }
  } catch (e) {
  }
}

//发送图片让原生显示web调用
function showimgjs_article(imgs) {
  console.log("============================");
  console.log(imgs)
  var url = $(imgs).src
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('showimg', { imgs: url, index: 0 }, function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.showimg(JSON.stringify({ imgs: url, index: 0 }));
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.showimg.postMessage({ imgs: url, index: 0 });
    }
  } catch (e) {
  }
}

//原生调用分享
function shareArticlejs(shardURL, sharedTitle, shareSummary, shareType, coverImgUrl) {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('shareArticle', { shardURL: shardURL, sharedTitle: sharedTitle, shareSummary: shareSummary, shareType: shareType, sharedImageURL: coverImgUrl }, function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.shareArticle(JSON.stringify({ shardURL: shardURL, sharedTitle: sharedTitle, shareSummary: shareSummary, shareType: shareType, sharedImageURL: coverImgUrl }));
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.shareArticle.postMessage({ shardURL: shardURL, sharedTitle: sharedTitle, shareSummary: shareSummary, shareType: shareType, sharedImageURL: coverImgUrl });
    }
  } catch (e) {
  }
}


//发送图片让原生显示cordova调用
function shareArticle(shardURL, sharedTitle, shareSummary, shareType, coverImgUrl) {
  // console.log("shareArticle============2222222");
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "shareArticle", [{ shardURL: shardURL, sharedTitle: sharedTitle, shareSummary: shareSummary, shareType: shareType, sharedImageURL: coverImgUrl }]);
  } catch (e) {
  }
}

//调用原生分享
function shareGoods(shareType, shardURL, sharedTitle, shareSummary, sharedImageURL) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "shareArticle", [{ shareType: shareType, shardURL: shardURL, sharedTitle: sharedTitle, shareSummary: shareSummary, sharedImageURL: sharedImageURL }]);
  } catch (e) {

  }
}

//关闭原生loading
function hideLoading() {
  try {
    if (window.WebViewJavascriptBridge) {
      //IOS
      window.WebViewJavascriptBridge.callHandler('hideLoading', '', function (response) { });
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.hideLoading();
    } else if (window.webkit) {
      //IOS 医生版
      window.webkit.messageHandlers.hideLoading.postMessage("postMessage");
    }
  } catch (e) {
  }
}
//发送图片让原生显示cordova调用
function showimg(imgs, index) {
  // console.log("showimg============");
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "showimg", [{ imgs: imgs, index: index }]);
  } catch (e) {
  }
}
//原生下载pdf
function getpdf(url, cid, hid, pacsid, extension) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "getpdf", [{ url: url, cid: cid, hid: hid, pacsid: pacsid, extension: extension }]);
  } catch (e) {
  }
}
//关闭窗口
function closewindows() {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "gotoHome", []);
  } catch (e) {
  }
}

function gotoNurseUrl(route) {
  try {
      cordova.exec(null, null, "CustomInteractivePlugin", "gotoNurseUrl", [{ route: route}]);
  } catch (e) {
      //console.log(e)
  }
}
//患者端网约护士调用原生聊天页面
function NursePatientChat(BussNo,CID ) {
  try {
      cordova.exec(null, null, "CustomInteractivePlugin", "NursePatientChat", [{ BussNo: BussNo, CID: CID}]);
  } catch (e) {
      //console.log(e)
  }
}
function loginSuccessBackToNurse(route) {
  try {
    cordova.exec(
      null,
      null,
      "CustomInteractivePlugin",
      "loginSuccessBackToNurse",
      [{ route: route }]
    );
  } catch (e) {
    //console.log(e)
  }
}

//帮帮安全
function bangbangSecurity() {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "activationBangBang", []);
  } catch (e) {
    //console.log(e)
  }
}
//向原生发送昵称同步
function toAddUpdateNickName(nickName) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "userInfoHasBeenModified", [{ nickName: nickName }]);
  } catch (e) {
    //console.log(e)
  }
}
//向原生发送消息
function toApp(userName, access_Token, refresh_token, cid, expires_in, nickName) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "loginCallback", [{ userName: userName, token: access_Token, refresh_token: refresh_token, cid: cid, expires_in: expires_in, nickName: nickName }]);
  } catch (e) {
    //console.log(e)
  }
}

//向原生发送消息
function setCookieParam(param, sig) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "setCookieParam", [{ param: param, sig: sig }]);
  } catch (e) {
    //console.log(e)
  }
}

//向原生发送登出
function logoutCallback() {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "logoutCallback");
  } catch (e) {
    //console.log(e)
  }
}

//隐藏状态栏，导航栏
function hideNativeNavigation() {
  try {
    // if (window.WebViewJavascriptBridge) {
    //     //IOS
    //     window.WebViewJavascriptBridge.callHandler('hideNativeNavigation', '', function (response) { });
    // }
    if (window.webkit) {
      //IOS
      window.webkit.messageHandlers.NavigationMethod.postMessage("hideNativeNavigation");
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.hideNativeNavigation();
    }
  } catch (e) {
  }
}

//调用原生打开网约护士业务详情
function getNurseBussDetail(successCallback, errorCallback, url) {
  try {
    cordova.exec(
      successCallback,
      errorCallback,
      "CustomInteractivePlugin",
      "getNurseBussDetail",
      [{ URL: url }]
    );
  } catch (e) {
    //console.log(e)
  }
}

//隐藏状态栏，导航栏
function showNativeNavigation() {
  try {
    if (window.webkit) {
      //IOS
      window.webkit.messageHandlers.NavigationMethod.postMessage("showNativeNavigation");
    }
    else if (window.WebViewFunc) {
      //android
      window.WebViewFunc.showNativeNavigation();
    }
  } catch (e) {
  }
}

function askDoctor(doctorCID, pid) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "askDoctor", [{ doctorCID: doctorCID, pid: pid }]);
  } catch (e) {
    //console.log(e)
  }
}
function openAppleMap(longitude, latitude, desAddress) {
    try {
        cordova.exec(null, null, "CustomInteractivePlugin", "openAppleMap", [{ longitude: longitude, latitude: latitude, desAddress: desAddress}]);
    } catch (e) {
        //console.log(e)
    }
}
//向原生调用实名认证
function callVerified(pid, successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "callVerified", [{ pid: pid }]);
  } catch (e) {
    //console.log(e)
  }
}
//向原生调用方法（公用）
function callAppPublic(successCallback, errorCallback, action, param) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", action, param);
  } catch (e) {
    //console.log(e)
  }
}

//调用原生获取电子签名
function getElecSing(name, successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getElecSing", [{ name: name }]);
  } catch (e) {
    //console.log(e)
  }
}

//调用原生获取
function getFace(successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "getFace", [{}]);
  } catch (e) {
    //console.log(e)
  }
}
function ValidationCodeErrorMsg() {
  $("#ValidationCodeErrorMsg").show();
}
function loadConfig() {
  var data_url = "";
  var auth_url = "";
  var resource_url = "";
  $.ajax({
    type: "GET",
    url: "config.json",
    dataType: "text",
    async: false,
    success: function (rs) {
      data_url = JSON.parse(rs).data_url
      auth_url = JSON.parse(rs).auth_url
      resource_url = JSON.parse(rs).resource_url
    },
    error: function (e) {
      //console.log(e)
    }
  });

  return [data_url, auth_url, resource_url];
}
//获取版本号
function loadVer() {
  var ver = "";
  $.ajax({
    type: "GET",
    url: "chcp.json",
    dataType: "text",
    async: false,
    success: function (rs) {
      ver = JSON.parse(rs).release
    },
    error: function (e) {
      //console.log(e)
    }
  });
  return ver;
}

//获取更新地址
function loadUpdateUrl() {
  var update_url = "";
  $.ajax({
    type: "GET",
    url: "chcp.json",
    dataType: "text",
    async: false,
    success: function (rs) {
      update_url = JSON.parse(rs).content_url
    },
    error: function (e) {
      //console.log(e)
    }
  });
  return update_url;
}
var isclose = false
var isfocus = false
var keyboardHeight = 0;
//获取键盘高度
function getkeyboardHeight() {
  return keyboardHeight;
}
function initKeyboard() {
  try {
    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
    cordova.plugins.Keyboard.disableScroll(true);
    window.addEventListener('native.keyboardshow', function (e) {
      keyboardHeight = e.keyboardHeight
      isclose = true
    });

    window.addEventListener('native.keyboardhide', function (e) {

      isclose = false
    });

    $("input").focus(function () {
      try {
        isfocus = true
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        cordova.plugins.Keyboard.disableScroll(true);
      }
      catch (e) { }
    })
  }
  catch (e) { }
}
function closeKeyboard() {
  try {
    //if (isclose)
    cordova.plugins.Keyboard.close();
  }
  catch (e) { }
}

function convertImgToBase64(url, callback) {
  var canvas = document.createElement('CANVAS');
  var ctx = canvas.getContext('2d');
  var img = new Image;
  img.crossOrigin = 'Anonymous';
  img.onload = function () {
    canvas.height = img.height;
    canvas.width = img.width;
    ctx.drawImage(img, 0, 0);
    var dataURL = canvas.toDataURL('image/png');
    callback.call(this, dataURL);
    // Clean up 
    canvas = null;
  };
  img.src = url;
}
function buildQrcode(divname, str, foreground = "#000000",width ="150",height='150') {
    try {
        $("#" + divname).qrcode({
            render: "canvas",    //设置渲染方式，有table和canvas，使用canvas方式渲染性能相对来说比较好
            text: str,    //扫描了二维码后的内容显示,在这里也可以直接填一个网址，扫描二维码后
            width: width,               //二维码的宽度
            height: height,              //二维码的高度
            background: "#ffffff",       //二维码的后景色
            foreground: foreground           //二维码的前景色
        });
    } catch (e) {
        $("#" + divname).hide()
    }
}
//showHRI 是否显示下面的数字
function buildBarcode(divname, str, showHRI, foreground = "#000000") {
  try {
    var settings = {
      output: "canvas",
      barWidth: 2,
      barHeight: 70,
      moduleSize: 5,
      posY: 0,
      posX: 83,
      showHRI: showHRI,
      addQuietZone: false,
      color: foreground
    };
    const re = new RegExp(/^[A-Za-z0-9]{4,40}$/, 'i');
    if (re.test(str))
      $("#" + divname).barcode(str, "code128", settings);
    else
      $("#" + divname).hide()
  } catch (e) {
    $("#" + divname).hide()
  }
}

var app = {

  // Application Constructor
  initialize: function () {
    this.bindEvents();
  },

  // Bind any events that are required.
  // Usually you should subscribe on 'deviceready' event to know, when you can start calling cordova modules
  bindEvents: function () {
    document.addEventListener('deviceready', this.onDeviceReady, false);
    document.addEventListener('chcp_updateIsReadyToInstall', this.onUpdateReady, false);
  },

  // deviceready Event Handler
  onDeviceReady: function () {
    console.log('Device is ready for work');
  },

  // chcp_updateIsReadyToInstall Event Handler
  onUpdateReady: function () {
    console.log('Update is ready for installation');
  }
};

app.initialize();
var isuse = false
function getVersionInfo() {
  if (!isuse) {
    isuse = true
    cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 1, msg: "" }]);
    fetchUpdate()
  }
}
function fetchUpdate() {
  var options = {
    'config-file': loadUpdateUrl() + '/chcp.json'
  };
  chcp.fetchUpdate(updateCallback, options);
  function updateCallback(error, data) {
    if (error) {
      console.log('没有可用更新', error.code, error.description);
    }
    checkIsUpdateAvailableForInstallation()
  }
}
function checkIsUpdateAvailableForInstallation() {
  chcp.isUpdateAvailableForInstallation(callbackMethod);
  function callbackMethod(error, data) {
    if (error) {
      cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 3, msg: "" }]);
      console.log('没有需要安装的更新');
    } else {
      cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 2, msg: "检测到有新的更新:" + data.readyToInstallVersion + "，即将安装更新……" }]);
      installUpdate()
    }
  }
}
function installUpdate() {
  chcp.installUpdate(installationCallback);
  function installationCallback(error) {
    if (error) {
      cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 5, msg: "更新失败" }]);
    } else {
      cordova.exec(null, null, "CustomInteractivePlugin", "haveNewVer", [{ code: 4, msg: "更新完毕" }]);
    }
  }
}

//向原生调用实名认证
function callVerified(pid, successCallback, errorCallback) {
  try {
    cordova.exec(successCallback, errorCallback, "CustomInteractivePlugin", "callVerified", [{ pid: pid }]);
  } catch (e) {
    //console.log(e)
  }
}
//关闭微信窗口
function closeWx() {
  WeixinJSBridge.call('closeWindow');
}
//隐藏右上角三个点按钮
function hideOptionMenu() {
  WeixinJSBridge.call('hideOptionMenu');
}
//是否在微信里
function isinwx() {
  var ua = navigator.userAgent.toLowerCase();
  if (ua.match(/MicroMessenger/i) == "micromessenger") {
    return true
  } else {
    return false
  }
}
//微信H5支付
function onBridgeReady(appId, package, nonceStr, timeStamp, paySign, total_fee, out_trade_no) {
  WeixinJSBridge.invoke(
    'getBrandWCPayRequest', {
    "appId": appId,     //公众号名称，由商户传入     
    "timeStamp": timeStamp,         //时间戳，自1970年以来的秒数     
    "nonceStr": nonceStr, //随机串     
    "package": package,
    "signType": "MD5",         //微信签名方式：     
    "paySign": paySign, //微信签名 

  },
    function (res) {
      if (res.err_msg == "get_brand_wcpay_request:ok") {
        window.parent.postMessage({ resultStatus: 'wxok', params: { total_fee: total_fee, out_trade_no: out_trade_no } }, '*');
      }     // 使用以上方式判断前端返回,微信团队郑重提示：res.err_msg将在用户支付成功后返回    ok，但并不保证它绝对可靠。
      else {
        window.parent.postMessage({ resultStatus: 'wxfalse', errormsg: "支付失败" }, '*');
      }
    }
  );
}
//通过config接口注入权限验证配置
function wxjsconfig(appid, timestamp, nonceStr, signature, jsApiList) {
  wx.config({
    debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
    appId: appid, // 必填，公众号的唯一标识
    timestamp: timestamp, // 必填，生成签名的时间戳
    nonceStr: nonceStr, // 必填，生成签名的随机串
    signature: signature,// 必填，签名，见附录1
    jsApiList: jsApiList// 必填，需要使用的JS接口列表，所有JS接口列表见附录2
  });
}
//隐藏右上角菜单接口
function hideOptionMenu() {
  wx.ready(function () {
    wx.hideOptionMenu()
  });

}
function onMenuShareTimeline(title, link) {
  wx.ready(function () {
    wx.onMenuShareTimeline({
      title: title,//自定义的标题
      link: link,//自定义的链接
      imgUrl: 'share/assets/logo.jpg',//自定义的图片
      trigger: function (res) {
      },
      success: function (res) {
        alert('成功')
      },
      cancel: function (res) {
        alert('成功')
      },
      fail: function (res) {
      }
    });
  })
}
function onMenuShareAppMessage(title, link, desc) {
  wx.ready(function () {
    wx.onMenuShareAppMessage({
      title: title,
      desc: desc,
      link: link,
      imgUrl: 'share/assets/logo.jpg',
      type: 'link',
      dataUrl: '',
      success: function () {
        alert('成功')
      },
      cancel: function () {
        alert('成功')
      }
    });
    wx.error(function (res) {
    });
  })
}

//=============支付宝===============
function AlipayJS(callback) {
  // 如果jsbridge已经注入则直接调用
  if (window.AlipayJSBridge) {
    callback && callback();
  } else {
    // 如果没有注入则监听注入的事件
    document.addEventListener('AlipayJSBridgeReady', callback, false);
  }
}
//关闭支付宝窗口
function closeAliWindow() {
  AlipayJS(function () {
    AlipayJSBridge.call('exitApp');
  })
}
function changecolor(css, val) {
  setTimeout(function () {
    $(css).each(function () {
      $(this).html($(this).html().replace(val, "<font color='red'>" + val + "</font>"))
    })
  }, 100)
}
function unReadMessagesChanged() {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "unReadMessagesChanged", null);
  }
  catch (e) {

  }
}

//base64转换
var Base64 = {

  // private property
  _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

  // public method for encoding
  encode: function (input) {
    var output = "";
    var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
    var i = 0;

    input = Base64._utf8_encode(input);

    while (i < input.length) {

      chr1 = input.charCodeAt(i++);
      chr2 = input.charCodeAt(i++);
      chr3 = input.charCodeAt(i++);

      enc1 = chr1 >> 2;
      enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
      enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
      enc4 = chr3 & 63;

      if (isNaN(chr2)) {
        enc3 = enc4 = 64;
      } else if (isNaN(chr3)) {
        enc4 = 64;
      }

      output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

    }

    return output;
  },

  // public method for decoding
  decode: function (input) {
    var output = "";
    var chr1, chr2, chr3;
    var enc1, enc2, enc3, enc4;
    var i = 0;

    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

    while (i < input.length) {

      enc1 = this._keyStr.indexOf(input.charAt(i++));
      enc2 = this._keyStr.indexOf(input.charAt(i++));
      enc3 = this._keyStr.indexOf(input.charAt(i++));
      enc4 = this._keyStr.indexOf(input.charAt(i++));

      chr1 = (enc1 << 2) | (enc2 >> 4);
      chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
      chr3 = ((enc3 & 3) << 6) | enc4;

      output = output + String.fromCharCode(chr1);

      if (enc3 != 64) {
        output = output + String.fromCharCode(chr2);
      }
      if (enc4 != 64) {
        output = output + String.fromCharCode(chr3);
      }

    }

    output = Base64._utf8_decode(output);

    return output;

  },

  // private method for UTF-8 encoding
  _utf8_encode: function (string) {
    string = string.replace(/\r\n/g, "\n");
    var utftext = "";

    for (var n = 0; n < string.length; n++) {

      var c = string.charCodeAt(n);

      if (c < 128) {
        utftext += String.fromCharCode(c);
      } else if ((c > 127) && (c < 2048)) {
        utftext += String.fromCharCode((c >> 6) | 192);
        utftext += String.fromCharCode((c & 63) | 128);
      } else {
        utftext += String.fromCharCode((c >> 12) | 224);
        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
        utftext += String.fromCharCode((c & 63) | 128);
      }

    }

    return utftext;
  },

  // private method for UTF-8 decoding
  _utf8_decode: function (utftext) {
    var string = "";
    var i = 0;
    var c = c1 = c2 = 0;

    while (i < utftext.length) {

      c = utftext.charCodeAt(i);

      if (c < 128) {
        string += String.fromCharCode(c);
        i++;
      } else if ((c > 191) && (c < 224)) {
        c2 = utftext.charCodeAt(i + 1);
        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
        i += 2;
      } else {
        c2 = utftext.charCodeAt(i + 1);
        c3 = utftext.charCodeAt(i + 2);
        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
        i += 3;
      }

    }

    return string;
  }
}
function encodeToBase64(str) {
  return Base64.encode(str);
}
function decodeToBase64(str) {
  return Base64.decode(str);
}
function getPicture(sourceType, successCallback, errorCallback) {
  navigator.camera.getPicture(successCallback, errorCallback, {
    quality: 50,
    destinationType: 0,//返回base64编码字符串
    sourceType: sourceType,
    encodingType: 0,//返回JPEG编码图像。
    mediaType: 0//仅允许选择图片。
  })

}

//调用原生发送挂号结果消息
function outpatientRegistrationBack(result, visitdate) {
  try {
    cordova.exec(null, null, "CustomInteractivePlugin", "outpatientRegistrationBack", [{ result: result, visitdate: visitdate }]);
  } catch (e) {
    //console.log(e)
  }
}
//调用原生复制单号
function copyStringToPasteBoard(data ) {
    try {
        cordova.exec(null, null, "CustomInteractivePlugin", "copyStringToPasteBoard", [{ data: data}]);
    } catch (e) {
        //console.log(e)
    }
}
//调用原生复制单号
function copyStringToPasteBoard(data) {
    try {
        cordova.exec(null, null, "CustomInteractivePlugin", "copyStringToPasteBoard", [{ data: data}]);
    } catch (e) {
        //console.log(e)
    }
  }
  //从剪贴板取数据
function getStringFromPasteBoard(successCallback) {
    try {
        cordova.exec(successCallback, null, "CustomInteractivePlugin", "getStringFromPasteBoard");
    } catch (e) {
        //console.log(e)
    }
  }
//获取网约护士版本号
function getNurseWWWVersion(successCallback) {
  try {
      cordova.exec(successCallback, null, "CustomInteractivePlugin", "getNurseWWWVersion");
  } catch (e) {
      //console.log(e)
  }
}
//调用原生群聊聊天页面
function teamConsultation(IGID, IGSaleID, GroupID,HID) {
  try {
      cordova.exec(null, null, "CustomInteractivePlugin", "teamConsultation", [{ IGID: IGID, IGSaleID: IGSaleID, GroupID: GroupID,HID:HID}]);
  } catch (e) {
      //console.log(e)
  }
}
